#!/usr/bin/perl -I/usr/sausalito/perl
# test snmp state

#use strict;
use warnings;
use AM::Util;
use CCE;

my $cce = new CCE;
$cce->connectuds();

my %am_states = am_get_statecodes();

my ($sysoid) = $cce->findx('System');
my ($ok, $object) = $cce->get($sysoid, 'Snmp');
if (!$ok) {
    $cce->bye('FAIL');
    exit $am_states{AM_STATE_NOINFO};
}

# return value of snmpwalk indicates if it successfully found the sysName
# property
my $fail = system("/usr/bin/snmpwalk -v 2c -c $object->{readCommunity} localhost system.sysName >/dev/null 2>&1");
if ($fail) {
    # can't directly call "system" since snmpd doesn't close stdin
    # and as a result, swatch would keep waiting forever
    # my_system handles the closing of stdin/stdout and so it all works
    AM::Util::my_system('/sbin/service snmpd restart >/dev/null 2>&1');
    sleep 3;
    $fail = system("/usr/bin/snmpwalk -v 2c -c $object->{readCommunity} localhost system.sysName >/dev/null 2>&1");
    if ($fail) {
        print $ENV{redMsg};
        exit $am_states{AM_STATE_RED};
    }
}

print $ENV{greenMsg};
exit $am_states{AM_STATE_GREEN};

# 
# Copyright (c) 2008-2022 Michael Stauber, SOLARSPEED.NET
# Copyright (c) 2008-2022 Team BlueOnyx, BLUEONYX.IT
# Copyright (c) 2003 Sun Microsystems, Inc. 
# All Rights Reserved.
# 
# 1. Redistributions of source code must retain the above copyright 
#    notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright 
#    notice, this list of conditions and the following disclaimer in 
#    the documentation and/or other materials provided with the 
#    distribution.
# 
# 3. Neither the name of the copyright holder nor the names of its 
#    contributors may be used to endorse or promote products derived 
#    from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
# POSSIBILITY OF SUCH DAMAGE.
# 
# You acknowledge that this software is not designed or intended for 
# use in the design, construction, operation or maintenance of any 
# nuclear facility.
# 